BMP Extension for Path Status TLV
Camilo Cardona
NTT
164-168, Carrer de Numancia
Barcelona
08029
Spain
camilo@ntt.net
Paolo Lucente
NTT
Siriusdreef 70-72
Hoofddorp
WT
2132
Netherlands
paolo@ntt.net
Pierre Francois
INSA-Lyon
Lyon
France
Pierre.Francois@insa-lyon.fr
Yunan Gu
Huawei
Huawei Bld., No.156 Beiqing Rd.
Beijing
100095
China
guyunan@huawei.com
Thomas Graf
Swisscom
Binzring 17
Zurich
8045
Switzerland
thomas.graf@swisscom.com
10 May 2022
The BGP Monitoring Protocol (BMP) provides an interface for obtaining BGP Path information. BGP Path Information is conveyed within BMP Route Monitoring (RM) messages. This document proposes an extension to BMP to convey the status of a BGP path before and after being processed by the BGP best-path selection algorithm. This extension makes use of the TLV mechanims described in draft-ietf-grow-bmp-tlv and draft-lucente-grow-bmp-tlv-ebit.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 RFC 2119 RFC 8174 when, and only when, they appear in all capitals, as shown here.

Introduction
For a given prefix, multiple paths with different path status, e.g., the "best-path", "back-up path" and so on, may co-exist in the BGP RIB after being processed by the local policy and the BGP decision process. The path status information is currently not carried in the BGP Update Message RFC4271 or in the BMP Update Message RFC7854.
External systems can use the path status for various applications. The path status is commonly checked by operators when performing troubleshooting. Having such status stored in a centralized system can enable the development of tools that facilitate this process. Optimisation systems can include the path status in their process, and also use the status as a validation source (since it can compare the calculated state to the actual outcome of the network, such as primary and backup path). As a final example, path status information can complement other centralized sources of data, for example, flow collectors.
This document defines a so-called Path Status TLV to convey the BGP path status to the BMP server. The BMP Path Status TLV is carried in the BMP Route Monitoring (RM) Message.

Path Status TLV
This document defines two types of Path Status TLVs: one is the IANA-registered Path Status TLV, and the other is the Enterprise-specific Path Status TLV.

IANA-registered Path Status TLV
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-------------------------------+-------------------------------+
|E|       Type (15 bits)        |       Length (2 octets)       |
+---------------------------------------------------------------+
|        Index (2 octets)       |
+-------------------------------+-------------------------------+
|                      Path Status (4 octets)                   |
+---------------------------------------------------------------+
|                 Reason Code (2 octets, optional)              |
+---------------------------------------------------------------+

    Figure 2: Encoding of IANA-Registered Path Status TLV
- E bit: For an IANA-registered TLV, the E bit MUST be set to 0.
- Type = TBD2 (15 Bits): indicates that it is the IANA-registered Path Status TLV.
- Length (2 Octets): indicates the length of the value field of the Path Status TLV. The value field further consists of the Path-Status field and Reason Code field.
- Index (2 Octets): indicates the prefix that this TLV is describing. The index is the encapsulation order, starting from 0, of the prefix in the BGP Update PDU.
- Path Status (4 Octets): indicates the path status of the BGP Update PDU encapsulated in the RM Message. Currently 8 types of path status are defined, as shown in Table 1. All zeros are reserved.
- Reason Code (2 Octets, optional): indicates the reason of the path status indicated in the Path Status field. The reason code field is optional. If no reason code is carried, this field is empty. If a reason code is carried, the reason code is indicated by a 2-byte value, which is defined in Table 2.
+------------+------------------+
| Value      | Path type        |
+-------------------------------+
| 0x00000001 | Invalid          |
| 0x00000002 | Best             |
| 0x00000004 | Non-selected     |
| 0x00000008 | Primary          |
| 0x00000010 | Backup           |
| 0x00000020 | Non-installed    |
| 0x00000040 | Best-external    |
| 0x00000080 | Add-Path         |
+------------+------------------+

Table 1: IANA-Registered Path Type
The Path Status field contains a bitmap where each bit encodes a specific role of the path. Multiple bits may be set when multiple path status apply to a path.
- The best-path is defined in RFC4271 and the best-external path is defined in draft-ietf-idr-best-external.
- An invalid path is a route that does not enter the BGP decision process.
- A non-selected path is a route that is not selected in the BGP decision process. Back-up routes are considered non-selected, while the best and ECMP routes are not considered as non-selected.
- A primary path is a recursive or non-recursive path whose nexthop resolution ends with an adjacency draft-ietf-rtgwg-bgp-pic. A prefix can have more than one primary path if multipath is configured draft-lapukhov-bgp-ecmp-considerations. A best-path is also considered as a primary path.
- A backup path is also installed in the RIB, but it is not used until some or all primary paths become unreachable. Backup paths are used for fast convergence in the event of failures.
- A non-installed path refers to the route that is not installed into the IP routing table.
- For the advertisement of multiple paths for the same address prefix without the new paths implicitly replacing any previous ones, the add-path status is applied RFC7911.
The path status TLV does not force a BMP client to send any of these paths. It just provides a method to mark the paths that are available with their status.
+----------+-----------------------------------------------------+
|   Value  | Reason code                                         |
+----------------------------------------------------------------+
| [0x0001] | invalid for super network                           |
| [0x0002] | invalid for dampening                               |
| [0x0003] | invalid for damping history                         |
| [0x0004] | invalid for policy deny                             |
| [0x0005] | invalid for ROV not valid                           |
| [0x0006] | invalid for interface error                         |
| [0x0007] | invalid for nexthop route unreachable               |
| [0x0008] | invalid for nexthop tunnel unreachable              |
| [0x0009] | invalid for nexthop restrain                        |
| [0x000A] | invalid for not supporting BGP LSP relay            |
| [0x000B] | invalid for being inactive within VPN insance       |
| [0x000C] | invalid for prefix sid not exist                    |
| [0x000D] | not preferred for peer address                      |
| [0x000E] | not preferred for router ID                         |
| [0x000F] | not preferred for Cluster List                      |
| [0x0010] | not preferred for IGP cost                          |
| [0x0011] | not preferred for peer type                         |
| [0x0012] | not preferred for MED                               |
| [0x0013] | not preferred for origin                            |
| [0x0014] | not preferred for AS Path                           |
| [0x0015] | not preferred for route type                        |
| [0x0016] | not preferred for Local preference                  |
| [0x0017] | not preferred for Weight                            |
| [0x0018] | not preferred for path to next hop with bit error   |
| [0x0019] | not preferred for path id                           |
| [0x001A] | not preferred for ROV validation                    |
| [0x001B] | not preferred for originate IP                      |
| [0x001C] | not preferred for route distinguisher               |
| [0x001D] | not preferred for delayed route selection           |
| [0x001E] | not preferred for imported from other instances     |
| [0x001F] | not preferred for med plus igp cost                 |
| [0x0020] | not preferred for AIGP                              |
| [0x0021] | not preferred for BGP LSP aigp for next hop relay   |
| [0x0022] | not preferred for nexthop IP                        |
+----------+-----------------------------------------------------+

               Table 2: IANA-Registered Reason Code

Enterprise-specific Path Status TLV
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-------------------------------+-------------------------------+
|E|       Type (15 bits)        |       Length (2 octets)       |
+-------------------------------+-------------------------------+
|                      PEN number (4 octets)                    |
+---------------------------------------------------------------+
|        Index (2 octets)       |
+---------------------------------------------------------------+
|                      Path Status (4 octets)                   |
+---------------------------------------------------------------+
|               Reason Code (2 octets, optional)                |
+---------------------------------------------------------------+

   Figure 3: Encoding of Enterprise-specific Path Status TLV
- E bit: For an Enterprise-specific TLV, the E bit MUST be set to 1.
- Type = 1 (15 Bits): indicates that it's the Enterprise-specific Path Status TLV.
- Length (2 Octets): indicates the length of the value field of the Path Status TLV. The value field further consists of the Path-Status field and Reason Code field.
- Index (2 Octets): indicates the prefix that this TLV is describing. The index is the encapsulation order, starting from 0, of the prefix in the BGP Update PDU.
- PEN Number (4 octets): indicates the IANA enterprise number IANA-PEN.
- Path Status (4 Octets): indicates the enterprise-specific path status. The format is to be determined w.r.t. each PEN number.
- Reason Code (2 octets, optional): indicates the reasons/explanations of the path status indicated in the Path Status field. The format is to be determined w.r.t. each PEN number.

Acknowledgments
We would like to thank Jeff Haas for his valuable comments.

IANA Considerations
This document requests that IANA assign the following new parameters to the BMP parameters name space.
Type = TBD1 (15 Bits): indicates that it is the IANA-registered Path Status TLV.

Security Considerations
It is not believed that this document adds any additional security considerations.

Normative References